diff --git a/corefreq-cli.c b/corefreq-cli.c
index ece69d5..3475a2f 100644
--- a/corefreq-cli.c
+++ b/corefreq-cli.c
@@ -2257,16 +2257,13 @@ void Top(SHM_STRUCT *Shm, char option)
 
     Coordinate *cTask;
 
-    double minRatio = Shm->Proc.Boost[BOOST(MIN)],
-	maxRatio = Shm->Proc.Boost[BOOST(1C)],
-	medianRatio=(Shm->Proc.Boost[BOOST(ACT)] > 0) ?
-			Shm->Proc.Boost[BOOST(ACT)] : (minRatio + maxRatio) / 2,
-	availRatio[BOOST(SIZE)] = {minRatio};
-
+    double minRatio, maxRatio, medianRatio, availRatio[BOOST(SIZE)];
 
     void ComputeAvailableRatio()
     {
 	unsigned int rdx;
+	for (rdx = BOOST(MIN); rdx < BOOST(SIZE); rdx++)
+		availRatio[rdx] = Shm->Proc.Boost[BOOST(MIN)];
 	// Update the ruller tab ratios.
 	minRatio = Shm->Proc.Boost[BOOST(MIN)];
 	maxRatio = Shm->Proc.Boost[BOOST(1C)];
diff --git a/corefreqk.c b/corefreqk.c
index 9c999af..0e60f0a 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -1473,8 +1473,8 @@ void Intel_Platform_Turbo(void)
 	PLATFORM_INFO Platform = {.value = 0};
 	RDMSR(Platform, MSR_PLATFORM_INFO);
 
-	Proc->Features.Ratio_Unlock = Platform.Ratio_Limited;
-	Proc->Features.TDP_Unlock = Platform.TDP_Limited;
+	Proc->Features.Ratio_Unlock = !Platform.Ratio_Limited;
+	Proc->Features.TDP_Unlock = !Platform.TDP_Limited;
 	Proc->Features.TDP_Levels = Platform.ConfigTDPlevels;
 
 	Proc->Boost[BOOST(MIN)] = Platform.MinimumRatio;
@@ -2656,6 +2656,9 @@ void Compute_AMD_Zen_Boost(void)
 	PSTATEDEF PstateDef = {.value = 0};
 	Proc->Features.SpecTurboRatio = 0;
 
+	for (index = BOOST(MIN); index < BOOST(SIZE); index++)
+		Proc->Boost[index] = 0;
+
 	// Core & L3 frequencies < 400MHz are not supported by the architecture
 	Proc->Boost[BOOST(MIN)] = 4;
 	// Loop over all frequency ids.
